package xyz.lychee.lagfixer.libs.adventure.permission;

import java.util.Objects;
import java.util.function.Predicate;
import xyz.lychee.lagfixer.libs.adventure.key.Key;
import xyz.lychee.lagfixer.libs.adventure.pointer.Pointer;
import xyz.lychee.lagfixer.libs.adventure.util.TriState;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface PermissionChecker extends Predicate<String> {
   Pointer<PermissionChecker> POINTER = Pointer.pointer(PermissionChecker.class, Key.key("adventure", "permission"));

   static @NotNull PermissionChecker always(final @NotNull TriState state) {
      Objects.requireNonNull(state);
      if (state == TriState.TRUE) {
         return PermissionCheckers.TRUE;
      } else {
         return state == TriState.FALSE ? PermissionCheckers.FALSE : PermissionCheckers.NOT_SET;
      }
   }

   @NotNull TriState value(final @NotNull String permission);

   default boolean test(final @NotNull String permission) {
      return this.value(permission) == TriState.TRUE;
   }
}
